%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Normal_vector = Get_Shell_Normal(Element_ID)

% Принадлежность элемента к типу Quad или Tria должна проверяться вне данной функции до ее вызова
% Существование элемента Element_ID должно проверяться вне данной функции до ее вызова

global DB_NODES;
global DB_ELEMENTS;

global AT_NODES;
global AT_ELEMENTS;

if (~(strcmp(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.type, 'Quad') || strcmp(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.type, 'Tria')))
    Normal_vector = [];
    return;
end

switch DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.N_nodes
    
    case 3
        
        d1_start_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1);
        d1_end_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2);
        
        d2_start_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1);
        d2_end_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3);
        
    case 4
        
        d1_start_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1);
        d1_end_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3);
        
        d2_start_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2);
        d2_end_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4);
        
    case 6
        
        d1_start_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1);
        d1_end_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2);
        
        d2_start_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1);
        d2_end_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3);
        
    case 8
        
        d1_start_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1);
        d1_end_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3);
        
        d2_start_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2);
        d2_end_ID = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4);
        
    otherwise
        
        Normal_vector = [];
        return;
        
end

d1 = DB_NODES{AT_NODES(d1_end_ID)}.Location - DB_NODES{AT_NODES(d1_start_ID)}.Location;
d2 = DB_NODES{AT_NODES(d2_end_ID)}.Location - DB_NODES{AT_NODES(d2_start_ID)}.Location;

Normal_vector = cross (d1,d2);
Normal_vector = Normal_vector/norm(Normal_vector);
